Subject: bug#2057 closed by Dan Nicolaescu <[email-masked]> (Re: bug#2057: 23.0.60; delete key and deletechar)

From: [email-masked] (Emacs bug Tracking System)
Date: Thu, 16 Apr 2009 18:30:04 +0000

This is an automatic notification regarding your bug report
which was filed against the emacs package:

#2057: 23.0.60; delete key and deletechar

It has been closed by Dan Nicolaescu <[email-masked]>.

Their explanation is attached below along with your original report.
If this explanation is unsatisfactory and you have not received a
better one in a separate message then please contact Dan Nicolaescu <[email-masked]> by
replying to this email.

-- 
2057: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=2057
Emacs Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#2057: 23.0.60; delete key and deletechar
From: Dan Nicolaescu <[email-masked]>
To: Robert Brown <[email-masked]>
Cc: [email-masked]
Date: Thu, 16 Apr 2009 11:17:48 -0700 (PDT)

Robert Brown <[email-masked]> writes:

  > Dan Nicolaescu writes:
  >  > Robert Brown <[email-masked]> writes:
  >  > 
  >  >   > I believe the following patch may be the right fix for bug 2057.  When
  >  >   > looking at the key sequences generated by function keys, Emacs should only
  >  >   > register those that generate two or more ASCII characters.
  >  >   > 
  >  >   > My termcap entry, xterm-color, contains "kD=\177", which means that the
  >  >   > delete *function* key generates code 177.
  >  > 
  >  > Interesting, it seems that you have a modified termcap database, the normal one
  >  > has kD=\E[3~ for xterm-color.
  > 
  > Yes, it's definitely a bug in the termcap entry.  Hitting the delete
  > function key generates \E[3~ for me.  I can fix the termcap.
  > 
  >  > Can you try setting TERM to xterm-256color and see if that the delete
  >  > key works better then?
  > 
  > Switching to a different termcap works well.

OK, so it's not an emacs bug, closing this then.

  > I still think it may incorrect for Emacs to map single character function
  > key sequences.  But perhaps these just never occur in practice.

Given that we don't have a positive proof that it causes a problem,
there doesn't seem to be a good reason to change code that has been
around for such a long time.

Subject: 23.0.60; delete key and deletechar
From: Robert Brown <[email-masked]>
To: [email-masked]
Date: Sun, 25 Jan 2009 18:01:26 -0500

Please write in English if possible, because the Emacs maintainers
usually do not have translators to read other languages for them.

Your bug report will be posted to the [email-masked] mailing list.

Please describe exactly what actions triggered the bug
and the precise symptoms of the bug:

I start Emacs 23.0.60.2 on Ubuntu 8.10 inside a gnome-terminal emulation
window using the command "emacs -q -nw".  The backspace key on my keyboard is
set up to generate ASCII code 127, but Emacs incorrectly maps this code to
deletechar with input-decode-map which is:

    (keymap (127 . [deletechar]) (27 keymap (79 keymap (83 . ....

I believe this input translation is set up by term_get_fkeys_1 in term.c when
it looks at the termcap/terminfo function key definitions for my terminal
type, xterm-color, and sees that the termcap description contains:

    kD=\177

which means that the delete *function* key produces ASCII code 127.

Emacs should look at both kD and kb.  If they are the same ASCII character,
then Emacs should not install a translation in input-decode-map for delete.

If Emacs crashed, and you have the Emacs process in the gdb debugger,
please include the output from the following gdb commands:
    `bt full' and `xbacktrace'.
If you would like to further debug the crash, please read the file
/local/software/package/emacs-23.0.60.2/share/emacs/23.0.60/etc/DEBUG
for instructions.

In GNU Emacs 23.0.60.2 (i686-pc-linux-gnu)
 of 2009-01-18 on ugg
configured using `configure  '--without-x'
'--prefix=/local/software/package/emacs-23.0.60.2''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: C
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: C
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default-enable-multibyte-characters: t

Major mode: Info

Minor modes in effect:
  savehist-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  global-auto-composition-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
ESC [ > 1 ; 1 7 0 4 ; 0 c C-h i m e m a c s RET C-s
b u g SPC C-a C-n C-f C-f C-f C-f C-f C-f RET SPC SPC
ESC x r e p o r t - e m a c s - b u g RET

Recent messages:
("emacs")
Composing main Info directory...done
Mark saved where search started